unit Ut_files;

interface

{ utilisation de fichiers }
function RepExiste (const UnRep : string) : Boolean;
{ dit si UnRep est un rpertoire ou une root }
function FichierExiste (const unFichier : string; MemeCache : Boolean) : boolean ;
{ FileExists en plus tendu }
function RepSansSlash (const UnRep : string) : string ;
function RepSansSlashpoint (const UnRep : string) : string ;
function RepPointe (const UnRep : string) : string ;
function IsDriveRoot (const unrep : string): Boolean;
function IsAFile (const UnFichier : string) : Boolean ;
function ExtractFichName (const UnFichier: string) : string ;
{ comme ExtractFileName mais plus laxiste sur exsietence }
{ True si est un fichier, mme cach ou systme, mais pas un
rpertoire ou un volumeID, ou inexistant }


implementation

{*******************************************************************}

uses SysUtils,
     Ut_Dialg, Ut_Str ;

function RepSansSlash (const UnRep : string) : string ;
{ sert  supprimer le \ final ventuel d'un nom de path}
  var n : integer ;
  begin
    n := Length(UnRep);
    if (unRep[n]='\')
        then Result := Copy(UnRep, 0, n-1)
        else Result := unRep;
  end ;

function RepSansSlashPoint (const UnRep : string) : string ;
 { supprime le point et \ final }
  var n : integer ;
  begin
    n := Length(UnRep);
    if (unRep[n]='.')
        then Result := Copy(UnRep, 0, n-1)
        else Result := unRep;
    Result := RepSanSSlash (Result) ;
  end ;


function RepPointe (const UnRep : string) : string ;
  { rajoute \.  un path }
  var n : integer ;
  begin
    n := Length (UnRep);
    if UnRep[n]='\' then Result := UnRep+'.'
                    else Result := UnRep+'\.';
  end ;

function IsDriveRoot (const unrep : string): Boolean;
  var ch : string ;
      dr, n,n2 : integer ;
  begin
    Result := False ;
    ch := RepSansSlashPoint (unrep);
    { voit dj s'il s'agit d'un lecteur non rseau }
    n := length(ch);
    if (n=2) and (ch[2]=':') then begin { c'en est un }
      { voit si existe }
      ch:=UpperCase(ch);
      dr := Ord(ch[1])-64 ;
      if dr>0 then
        if DiskSize(dr)>0 then
          Result := True ;
    end else begin
       n2:=pos('\\', ch);
       if n2=1 then begin { lecteur rseau}
         ch := copy (ch, n2+1, n);
         if pos('\', ch)=0 then begin
           { pas d'autre \}
           ch:=UpperCase(ch);
           dr := Ord(ch[1])-64 ;
           if dr>0 then begin  { suppose que la 1re lettre est celle d'un lecteur virtuel rseau }
             if DiskSize(dr)>0 then begin
               Result := True ;
             end ;
           end ;
         end ;
       end;
    end ; { fin else}
  end ;

function RepExiste (const UnRep : string) : Boolean;
 { dit si UnRep est un rpertoire ou une root }
  var UnSearchRec : TSearchRec ;
      utilstr : string ;
  begin
    UtilStr := RepPointe (UnRep) ;
   { yesbox ('utilstr '+utilstr);}
    UnSearchRec.Name := '--';
    FindFirst (utilstr, faDirectory, UnSearchRec);
    FindClose (UnSearchRec);

    Result := ((UnSearchRec.Name<>'--') or IsDriveRoot (unRep))
              and (not IsAFile (unrep));
  end ;

function IsAFile (const UnFichier : string) : Boolean ;
{ True si est un fichier, mme cach ou systme, mais pas un
rpertoire ou un volumeID, ou inexistant }
  var c : Char ;
      fa : Word ;
  begin
    Result := true ;
    c := UnFichier [Length(UnFichier)] ;
    if (c='.') or(c='\') then
      Result := False
    else if not FileExists (UnFichier) then
        Result := False
        else begin
          fa := FileGetAttr (unFichier);
          if  ((fa and faDirectory)=faDirectory) or
              ((fa and faVolumeID)=faVolumeID ) then
            Result := False
        end ;
  end ;

function ExtractFichName (const UnFichier : string) : string ;
  var p : integer ;
      str : string ;
  begin
    str := UnFichier  ;
    repeat
      p := Pos ('\', str);
      str := Copy(str, p+1, length(str)-p+1);
    until p=0;
    Result := str ;
  end ;

function FichierExiste (const unFichier : string; MemeCache:Boolean) : boolean ;
  var UnSearchRec : TSearchRec ;
      utilstr : string ;
      fa : Word ;
  begin
    if MemeCache then fa:=faHidden+faSysFile
                 else fa:=faAnyFile ;
    utilstr := unFichier ;
    UnSearchRec.Name := '--';
    FindFirst (utilstr, fa, UnSearchRec);
    FindClose (UnSearchRec);

    Result := (UnSearchRec.Name<>'--');

  end ;

{initialization
  YesBox ('g:\internet\'+ OuiNon(RepExiste('g:\internet\')));
  YesBox ('g:\internet'+ OuiNon(RepExiste('g:\internet')));
  YesBox ('g:\'+ OuiNon(RepExiste('g:\')));
  YesBox ('d:\'+ OuiNon(RepExiste('d:\')));
  YesBox ('c:'+ OuiNon(RepExiste('c:')));
  YesBox ('l:\'+ OuiNon(RepExiste('l:\')));}
end.
